<template>
  <div id="listPage">

    <section class="section">
      <div class="tile is-ancestor columns is-multiline">
        <b-message type="is-warning" has-icon v-show="((movieList || []).length === 0) && (loading === false)">
          Lorem ipsum dolor sit amet, consectetur warning elit. Fusce id fermentum quam. Proin sagittis, nibh id hendrerit imperdiet, elit sapien laoreet elit
        </b-message>
        <div class="tile is-parent column is-4" v-for="(item, idx) in movieList" :key="idx">
          <article class="tile is-child box" v-on:click="check(item.imdbID)">
            <dif v-show="loading === true">
              <b-skeleton height="500px" />
            </dif>
            <dif v-show="loading === true">
              <br />
              <b-skeleton size="is-large" />
            </dif>
            <figure class="image is-fullwidth is-2by3" v-show="loading === false">
              <img v-bind:src="item.Poster" alt="Poster">
            </figure>
            <p class="title" v-show="loading === false">
              {{item.Title}}
              <span>({{item.Year}})</span>
            </p>
          </article>
        </div>
      </div>
    </section>

    <section class="section">
      <b-pagination
        :total="totalItem"
        :current.sync="current"
        range-before="2"
        range-after="2"
        order="is-centered"
        size="small"
        :rounded="true"
        per-page="10"
        aria-next-label="Next page"
        aria-previous-label="Previous page"
        aria-page-label="Page"
        aria-current-label="Current page"
        v-on:change="handlePage"
      />
    </section>

  </div>
</template>

<script>
  import { mapState, mapGetters } from 'vuex'
  import { pickBy, identity } from 'lodash'
  import qs from 'query-string'
  import router from '../router'
  export default {
    name: 'listPage',
    data: () => (
      {
        current: Number((qs.parse(window.location.search) || {}).page) || 1,
      }
    ),
    mounted () {
      const { search, pathname } = window.location
      this.$store.dispatch('loadMovie', (search || '?s=batman'))

      const loadingComponent = this.$buefy.loading.open({ container: null })
      setTimeout(() => loadingComponent.close(), 3 * 1000)
    },
    methods: {
      handlePage (val) {
        const { search, pathname } = window.location;
        const payload = {
          ...qs.parse(search),
          s: (qs.parse(search) || {}).s || 'batman',
          page: val,
        }
        this.$store.dispatch(
          'loadMovie',
          `?${qs.stringify(pickBy(payload, identity))}`
        )
        return router.push(pathname + `?${qs.stringify(pickBy(payload, identity))}`)
      },
      check: (val) => (
        router.push(`/${val}`)
      )
    },
    computed: {
      ...mapState([
        'movieList',
        'totalItem'
      ]),
      ...mapGetters([ 'loading' ])
    }
  }
</script>
